
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>图像处理------特殊灰度算法技巧 / iVAN</title>

    <meta name="description" content="图像处理------特殊灰度算法技巧 介绍几种特殊的灰度算法滤镜,将彩色图像转换为灰度图像.其中涉及到的有基于阈值的图 像二值化,弗洛伊德.斯坦德伯格抖动算法,基于阈值的部分灰度化   基础知识- 怎么把RGB转换为单色的[0 ~256]之间的灰度,最常用的转换公式如下: Gray = 0.299 * red + 0.587 * green + 0.114 * blue;   1.       基于像素平均值的图像阈值二值化算法: 处理流程: a.      首先将彩色图像转换为灰度图像 b.      计算灰度图像的算术平均值–">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">图像处理------特殊灰度算法技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>介绍几种特殊的灰度算法滤镜，将彩色图像转换为灰度图像。其中涉及到的有基于阈值的图</p>
<p>像二值化，弗洛伊德.斯坦德伯格抖动算法，基于阈值的部分灰度化</p>
<p> </p>
<p><strong>基础知识- </strong>怎么把RGB转换为单色的[0 ~256]之间的灰度，最常用的转换公式如下：</p>
<p>Gray = 0.299 * red + 0.587 * green + 0.114 * blue;</p>
<p> </p>
<p><strong>1.       基于像素平均值的图像阈值二值化算法：</strong></p>
<p><strong>处理流程：</strong></p>
<p>a.      首先将彩色图像转换为灰度图像</p>
<p>b.      计算灰度图像的算术平均值– M</p>
<p>c.      以M为阈值，完成对灰度图二值化( 大于阈值M,像素点赋值为白色，否则赋值为黑</p>
<p>色)</p>
<p><strong>图像效果：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDMvMjUvMTMzMjY2MzU1M18zMDM2LnBuZw==.jpg"></p>
<p><strong>关键代码：</strong></p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public BufferedImage filter(BufferedImage src, BufferedImage dest) {  </li>
<li>    int width = src.getWidth();  </li>
<li>       int height = src.getHeight();  </li>
<li>  </li>
<li>       if ( dest == null )  </li>
<li>           dest = createCompatibleDestImage( src, null );  </li>
<li>       src = super.filter(src, dest);  </li>
<li>  </li>
<li>       int[] inPixels = new int[width*height];  </li>
<li>       int[] outPixels = new int[width*height];  </li>
<li>       getRGB(src, 0, 0, width, height, inPixels );  </li>
<li>         </li>
<li>       // calculate means of pixel    </li>
<li>       int index = 0;    </li>
<li>       double redSum = 0, greenSum = 0, blueSum = 0;    </li>
<li>       double total = height * width;    </li>
<li>       for(int row=0; row&lt;height; row++) {    </li>
<li>           int ta = 0, tr = 0, tg = 0, tb = 0;    </li>
<li>           for(int col=0; col&lt;width; col++) {    </li>
<li>               index = row * width + col;    </li>
<li>               ta = (inPixels[index] &gt;&gt; 24) &amp; 0xff;    </li>
<li>               tr = (inPixels[index] &gt;&gt; 16) &amp; 0xff;    </li>
<li>               tg = (inPixels[index] &gt;&gt; 8) &amp; 0xff;    </li>
<li>               tb = inPixels[index] &amp; 0xff;    </li>
<li>               redSum += tr;    </li>
<li>               greenSum += tg;    </li>
<li>               blueSum +=tb;    </li>
<li>           }    </li>
<li>       }  </li>
<li>       int means = (int)(redSum / total);  </li>
<li>       System.out.println(" threshold average value = " + means);  </li>
<li>         </li>
<li>       // dithering   </li>
<li>       for(int row=0; row&lt;height; row++) {  </li>
<li>        int ta = 0, tr = 0, tg = 0, tb = 0;  </li>
<li>        for(int col=0; col&lt;width; col++) {  </li>
<li>            index = row * width + col;  </li>
<li>            ta = (inPixels[index] &gt;&gt; 24) &amp; 0xff;  </li>
<li>               tr = (inPixels[index] &gt;&gt; 16) &amp; 0xff;  </li>
<li>               tg = (inPixels[index] &gt;&gt; 8) &amp; 0xff;  </li>
<li>               tb = inPixels[index] &amp; 0xff;  </li>
<li>               if(tr &gt;=means) {  </li>
<li>                tr = tg = tb = 255;  </li>
<li>               } else {  </li>
<li>                tr = tg = tb = 0;  </li>
<li>               }  </li>
<li>               outPixels[index] = (ta &lt;&lt; 24) | (tr &lt;&lt; 16) | (tg &lt;&lt; 8) | tb;  </li>
<li>                 </li>
<li>        }  </li>
<li>       }  </li>
<li>       setRGB( dest, 0, 0, width, height, outPixels );  </li>
<li>       return dest;  </li>
<li>}  </li>
</ol>
<p><strong>2.       基于错误扩散的Floyd-Steinberg抖动算法</strong></p>
<p>关于什么是Floyd-Steinberg抖动，参见这里</p>
<p><a href="http://en.wikipedia.org/wiki/Floyd%E2%80%93Steinberg_dithering" rel="external nofollow noreferrer">http://en.wikipedia.org/wiki/Floyd–Steinberg_dithering</a></p>
<p><strong>图像效果：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDMvMjUvMTMzMjY2MzY1MV82MTk1LnBuZw==.jpg"></p>
<p><strong>关键代码：</strong></p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>@Override  </li>
<li>public BufferedImage filter(BufferedImage src, BufferedImage dest) {  </li>
<li>    int width = src.getWidth();  </li>
<li>       int height = src.getHeight();  </li>
<li>  </li>
<li>       if ( dest == null )  </li>
<li>        dest = createCompatibleDestImage( src, null );  </li>
<li>       src = super.filter(src, dest);  </li>
<li>  </li>
<li>       int[] inPixels = new int[width*height];  </li>
<li>       int[] outPixels = new int[width*height];  </li>
<li>       getRGB( src, 0, 0, width, height, inPixels );  </li>
<li>       int index = 0;  </li>
<li>       for(int row=0; row&lt;height; row++) {  </li>
<li>        for(int col=0; col&lt;width; col++) {  </li>
<li>            index = row * width + col;  </li>
<li>               int r1 = (inPixels[index] &gt;&gt; 16) &amp; 0xff;  </li>
<li>               int g1 = (inPixels[index] &gt;&gt; 8) &amp; 0xff;  </li>
<li>               int b1 = inPixels[index] &amp; 0xff;  </li>
<li>               int cIndex = getCloseColor(r1, g1, b1);  </li>
<li>               outPixels[index] = (255 &lt;&lt; 24) | (COLOR_PALETTE[cIndex][0] &lt;&lt; 16) | (COLOR_PALETTE[cIndex][1] &lt;&lt; 8) | COLOR_PALETTE[cIndex][2];  </li>
<li>               int er = r1 - COLOR_PALETTE[cIndex][0];  </li>
<li>               int eg = g1 - COLOR_PALETTE[cIndex][1];  </li>
<li>               int eb = b1 -  COLOR_PALETTE[cIndex][2];  </li>
<li>               int k = 0;  </li>
<li>                 </li>
<li>               if(row + 1 &lt; height &amp;&amp; col - 1 &gt; 0) {  </li>
<li>                k = (row + 1) * width + col - 1;  </li>
<li>                   r1 = (inPixels[k] &gt;&gt; 16) &amp; 0xff;  </li>
<li>                   g1 = (inPixels[k] &gt;&gt; 8) &amp; 0xff;  </li>
<li>                   b1 = inPixels[k] &amp; 0xff;  </li>
<li>                   r1 += (int)(er * kernelData[0]);  </li>
<li>                   g1 += (int)(eg * kernelData[0]);  </li>
<li>                   b1 += (int)(eb * kernelData[0]);  </li>
<li>                   inPixels[k] = (255 &lt;&lt; 24) | (clamp(r1) &lt;&lt; 16) | (clamp(g1) &lt;&lt; 8) | clamp(b1);  </li>
<li>               }  </li>
<li>                 </li>
<li>               if(col + 1 &lt; width) {  </li>
<li>                k = row * width + col + 1;  </li>
<li>                   r1 = (inPixels[k] &gt;&gt; 16) &amp; 0xff;  </li>
<li>                   g1 = (inPixels[k] &gt;&gt; 8) &amp; 0xff;  </li>
<li>                   b1 = inPixels[k] &amp; 0xff;  </li>
<li>                   r1 += (int)(er * kernelData[3]);  </li>
<li>                   g1 += (int)(eg * kernelData[3]);  </li>
<li>                   b1 += (int)(eb * kernelData[3]);  </li>
<li>                   inPixels[k] = (255 &lt;&lt; 24) | (clamp(r1) &lt;&lt; 16) | (clamp(g1) &lt;&lt; 8) | clamp(b1);  </li>
<li>               }  </li>
<li>                 </li>
<li>               if(row + 1 &lt; height) {  </li>
<li>                k = (row + 1) * width + col;  </li>
<li>                   r1 = (inPixels[k] &gt;&gt; 16) &amp; 0xff;  </li>
<li>                   g1 = (inPixels[k] &gt;&gt; 8) &amp; 0xff;  </li>
<li>                   b1 = inPixels[k] &amp; 0xff;  </li>
<li>                   r1 += (int)(er * kernelData[1]);  </li>
<li>                   g1 += (int)(eg * kernelData[1]);  </li>
<li>                   b1 += (int)(eb * kernelData[1]);  </li>
<li>                   inPixels[k] = (255 &lt;&lt; 24) | (clamp(r1) &lt;&lt; 16) | (clamp(g1) &lt;&lt; 8) | clamp(b1);  </li>
<li>               }  </li>
<li>                 </li>
<li>               if(row + 1 &lt; height &amp;&amp; col + 1 &lt; width) {  </li>
<li>                k = (row + 1) * width + col + 1;  </li>
<li>                   r1 = (inPixels[k] &gt;&gt; 16) &amp; 0xff;  </li>
<li>                   g1 = (inPixels[k] &gt;&gt; 8) &amp; 0xff;  </li>
<li>                   b1 = inPixels[k] &amp; 0xff;  </li>
<li>                   r1 += (int)(er * kernelData[2]);  </li>
<li>                   g1 += (int)(eg * kernelData[2]);  </li>
<li>                   b1 += (int)(eb * kernelData[2]);  </li>
<li>                   inPixels[k] = (255 &lt;&lt; 24) | (clamp(r1) &lt;&lt; 16) | (clamp(g1) &lt;&lt; 8) | clamp(b1);  </li>
<li>               }  </li>
<li>        }  </li>
<li>       }  </li>
<li>       setRGB( dest, 0, 0, width, height, outPixels );  </li>
<li>       return dest;  </li>
<li>}  </li>
</ol>
<p>3.       选择性灰度算法<br />
<br />计算选择的颜色与像素灰度颜色之间的几何距离值，跟阈值比较决定是否像素点为灰度</p>
<p>值，可以得到一些让你意想不到的图像处理效果！</p>
<p><strong>图像效果 (Main Color = GREEN, 阈值 = 200)</strong></p>
<p><strong>原图：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDMvMjUvMTMzMjY2MzY5N185OTY3LnBuZw==.jpg"></p>
<p><strong>处理以后</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDMvMjUvMTMzMjY2MzcxN182ODQ5LnBuZw==.jpg"></p>
<p><strong> 关键代码：</strong></p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public BufferedImage filter(BufferedImage src, BufferedImage dest) {  </li>
<li>    int width = src.getWidth();  </li>
<li>       int height = src.getHeight();  </li>
<li>  </li>
<li>       if ( dest == null )  </li>
<li>        dest = createCompatibleDestImage( src, null );  </li>
<li>  </li>
<li>       int[] inPixels = new int[width*height];  </li>
<li>       int[] outPixels = new int[width*height];  </li>
<li>       getRGB( src, 0, 0, width, height, inPixels );  </li>
<li>       int index = 0;  </li>
<li>       for(int row=0; row&lt;height; row++) {  </li>
<li>        int ta = 0, tr = 0, tg = 0, tb = 0;  </li>
<li>        for(int col=0; col&lt;width; col++) {  </li>
<li>            index = row * width + col;  </li>
<li>            ta = (inPixels[index] &gt;&gt; 24) &amp; 0xff;  </li>
<li>               tr = (inPixels[index] &gt;&gt; 16) &amp; 0xff;  </li>
<li>               tg = (inPixels[index] &gt;&gt; 8) &amp; 0xff;  </li>
<li>               tb = inPixels[index] &amp; 0xff;  </li>
<li>               int gray = (int)(0.299 * (double)tr + 0.587 * (double)tg + 0.114 * (double)tb);  </li>
<li>               double distance = getDistance(tr, tg, tb);  </li>
<li>               if(distance &lt; threshold) {  </li>
<li>                double k = distance / threshold;  </li>
<li>                int[] rgb = getAdjustableRGB(tr, tg, tb, gray, (float)k);  </li>
<li>                tr = rgb[0];  </li>
<li>                tg = rgb[1];  </li>
<li>                tb = rgb[2];  </li>
<li>                outPixels[index] = (ta &lt;&lt; 24) | (tr &lt;&lt; 16) | (tg &lt;&lt; 8) | tb;  </li>
<li>               } else {  </li>
<li>                outPixels[index] = (ta &lt;&lt; 24) | (gray &lt;&lt; 16) | (gray &lt;&lt; 8) | gray;                      </li>
<li>               }  </li>
<li>                 </li>
<li>        }  </li>
<li>       }  </li>
<li>       setRGB( dest, 0, 0, width, height, outPixels );  </li>
<li>       return dest;  </li>
<li>}  </li>
</ol>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>创建新的目标Image  </li>
</ol>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/jia20003/article/details/7392325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public BufferedImage createCompatibleDestImage(BufferedImage src, ColorModel dstCM) {  </li>
<li>    if ( dstCM == null )  </li>
<li>        dstCM = src.getColorModel();  </li>
<li>    return new BufferedImage(dstCM, dstCM.createCompatibleWritableRaster(src.getWidth(), src.getHeight()), dstCM.isAlphaPremultiplied(), null);  </li>
<li>}  </li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 01:48:04</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>图像处理------特殊灰度算法技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze66yAb.html" rel="bookmark">计算机视觉 图像处理-相似图像分割算法实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 相似图像分割算法实现 如下:两块材料一样,颜色一样的布料,如何用算法分割开?,canny算法和一些一般梯度算法都不能的到好的结果.计算机视觉 图像处理-相似图像分割算法实现-图像分割 计算机视觉&quot;&gt; 解决方案 用分水岭算法实现图像分割 (祝勇)图片像素对比OpenCV实现,实现人工分割跟算法分割图像结果的对比基于GraphCuts图割算法的图像分割----OpenCV代码与实现 解决方案二: 这需要比较专业的算法才能识别吧 至少要先提取给关键点,然后根据关键点是否相同的区分.因为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYxZVb.html" rel="bookmark">一个经典实用的PHP图像处理类分享&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本图像处理类可以完成对图片的缩放.加水印和裁剪的功能,支持多种图片类型的处理,缩放时进行优化等. &lt;?php /** file: image.class.php 类名为Image 图像处理类,可以完成对各种类型的图像进行缩放.加图片水印和剪裁的操作. */ class Image { /* 图片保存的路径 */ private $path; /** * 实例图像对象时传递图像的一个路径,默认值是当前目录 * @param string $path 可以指定处理图片的路径 */ function			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL5d9Lz.html" rel="bookmark">PHP基于GD库的图像处理方法小结&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP基于GD库的图像处理方法.分享给大家供大家参考,具体如下: gd图像处理技术 extension=php_gd2.dll 创建画布 画布,一种资源型数据,可操作的图像资源 创建画布(新建) imageCreate(width,height) //创建基于调色板的画布 imageCreateTrueColor(width,height) //创建真彩色的画布 基于图片创建画布(打开) imageCreateFromJPEG( url) imageCreateFromPNG(ur			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQrQXOM.html" rel="bookmark">图像处理------泛洪填充算法&lpar;Flood Fill Algorithm&rpar;  油漆桶功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				泛洪填充算法(Flood Fill Algorithm) 泛洪填充算法又称洪水填充算法是在很多图形绘制软件中常用的填充算法,最熟悉不过就是 windows paint的油漆桶功能.算法的原理很简单,就是从一个点开始附近像素点,填充成新 的颜色,直到封闭区域内的所有像素点都被填充新颜色为止.泛红填充实现最常见有四邻域 像素填充法,八邻域像素填充法,基于扫描线的像素填充方法.根据实现又可以分为递归与 非递归(基于栈).   在介绍算法的三种实现方式之前,首先来看一下测试该算法的UI实现.基本思路是选			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmvERp.html" rel="bookmark">php图像处理类实例&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php图像处理类.分享给大家供大家参考.具体如下: &lt;?php /** * Image 类 */ class Image { /** * @var string $fileName 文件名 * @access private */ private $fileName = ''; /** * @var gd resource $imageResource 原图像 * @access private */ private $imageResource = NULL; /** * @va			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2w1jb.html" rel="bookmark">【数字图像处理】三&period;MFC实现图像灰度、采样和量化功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        本文主要讲述基于VC++6.0 MFC图像处理的应用知识,主要结合自己大三所学课程&lt;数字图像处理&gt;及课件进行讲解,主要通过MFC单文档视图实现显示BMP格式图片,并通过Bitmap进行灰度处理.图片采样和量化功能.         个人认为对初学者VC++6.0可能还是很值得学习的工具,所以采用它来讲解,而不是VS或C#.同时文章比较详细基础,希望该篇文章对你有所帮助~        [数字图像处理]一.MFC详解显示BMP格式图片        [数字图像处理]二.MFC单文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32AlAz.html" rel="bookmark">【数字图像处理】四&period;MFC对话框绘制灰度直方图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        本文主要讲述基于VC++6.0 MFC图像处理的应用知识,主要结合自己大三所学课程&lt;数字图像处理&gt;及课件进行回忆讲解,主要通过MFC单文档视图实现点击弹出对话框绘制BMP图片的灰度直方图,再获取平均灰度.中指灰度和标准差等值.文章比较详细基础,希望该篇文章对你有所帮助~        [数字图像处理]一.MFC详解显示BMP格式图片        [数字图像处理]二.MFC单文档分割窗口显示图片        [数字图像处理]三.MFC实现图像灰度.采样和量化功能详解    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnLVEjb.html" rel="bookmark">JavaScript实现的MD5算法完整实例&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JavaScript实现MD5算法的方法.分享给大家供大家参考,具体如下: /** * * MD5 (Message-Digest Algorithm) * http://www.webtoolkit.info/ * **/ var MD5 = function (string) { function RotateLeft(lValue, iShiftBits) { return (lValue&lt;&lt;iShiftBits) | (lValue&gt;&gt;&gt;(32-iShi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMA43nb.html" rel="bookmark">运用Visual C&num;完成基本数字图像处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				visual 一．概述: 本文的实例是一个数字图像处理的应用程序,它完成的功能包括对图像颜色的翻转.对图像进行灰度处理和对图像进行增亮处理.该程序对图像进行处理部分的代码包含在一个专门的Filters类里面,通过调用该类里的静态成员函数,我们就可以实现相应的图像处理功能了.为实现图像处理,我们要对图像进行逐个象素处理.我们知道图像是由一个个的象素点组成的,对一幅图像的每个象素进行了相应的处理,最后整个图像也就处理好了.在这个过程中,我们只需对每个象素点进行相应的处理,在处理过程中却不需要考虑周围			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M03jAb.html" rel="bookmark" class="title">PHP5中使用Web服务访问J2EE应用程序&lpar;2&rpar;</a>
					<div>
						j2ee|php5|web|web服务|程序|访问 PHP Weather 客户机 这一节将建立我们自己的 PHP Weather 客户机.这里提供了一些代码片段,建议下载完整的客户机和 WSDL 文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV53Bp.html" rel="bookmark" class="title">C＃实现Web文件的上传</a>
					<div>
						web|上传    C#实现Web文件的上传-1using System;using System.Data;using System.Data.SqlClient;using System.Web. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2JZrM.html" rel="bookmark" class="title">Oracle 10g中可以通过列方式指定HINT</a>
					<div>
						看优化文档的时候发现,指定索引的HINT还可以通过列方式. 在9i和以前的版本,索引提示的格式为/*+ index(table_alias) */或/*+ index(table_alias inde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKvaEM.html" rel="bookmark" class="title">c&num;后台修改前台DOM的css属性示例代码</a>
					<div>
						本文为大家详细介绍下如何使用c#修改前台DOM的css属性,具体示例如下,感兴趣的朋友可以参考下哈,希望对大家有所帮助   &lt;div id = 'div1' runat=&quot;server ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVn1rlz.html" rel="bookmark" class="title">jquery和javascript的区别&lpar;常用方法比较&rpar;</a>
					<div>
						jquery 就对javascript的一个扩展,封装,就是让javascript更好用,更简单.人家怎么说的来着,jquery就是要用更少的代码,漂亮的完成更多的功能.JavaScript 与JQu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB4wAb.html" rel="bookmark" class="title">excel表格如何按成绩排序</a>
					<div>
						  excel按成绩排序步骤如下: 方法一.打开Excel表格,光标定位到做为排序依据的成绩列(zf),点击常用工具栏中的&quot;降序排序&quot;按钮.就可以让整个表依&quot;zf&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8W2Yb.html" rel="bookmark" class="title">word中如何修改剪贴图颜色</a>
					<div>
						Word2003是微软公司提供的一款文字处理软件,可以对文字进行排版和编辑.分段等各种处理,最终将编辑好的内容打印出来,是办公室一族中必备的办公软件之一, 这一课,Word联盟小编将为大家分享如何在W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6BeAb.html" rel="bookmark" class="title">win7旗舰版系统玩游戏经常出现&OpenCurlyDoubleQuote;&period;exe已经停止工作&rdquo;的解决方法</a>
					<div>
						win7旗舰版系统玩游戏经常出现&quot;.exe已经停止工作&quot;的解决方法  1.可以右键启动程序--属性--兼容性-选择windows xp sp3--确定. 2.如果是最新的游戏出现这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72X5qp.html" rel="bookmark" class="title">Mac清理过程中如何避免误删CleanMyMac语言文件</a>
					<div>
						  如果需要设置软件扫描的时候不移除某些特定的语言文件,我们可以自行设置不要从系统或者应用程序中移除以下语言,设置方法如下: 1.启动CleanMyMac,然后选择&quot;CleanMyMac3& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKxVkM.html" rel="bookmark" class="title">win7系统如何开启高级电源管理的方法教程</a>
					<div>
						  操作方法 1.首先要进入到CMOS进行设置才可以了. 2.接着在上面找到POWER MANAGEMENT的选项. 3.最后依次执行下面的操作: Power After Pwp-Tail (ON-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd6ooM.html" rel="bookmark" class="title">碗豆夹账号有什么作用</a>
					<div>
						  豌豆夹界面 可以说,碗豆夹账号是您在碗豆夹唯一的身份标识. 您可以使用 Email.手机号码等多种方式注册,您也可以通过新浪微博.QQ账号与人人账号登录. 注册碗豆夹账号后,您可以使用碗豆夹提供的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZQ0lb.html" rel="bookmark" class="title">windows live mail本地文件的存储位置路径在哪里</a>
					<div>
						  在使用windows live mail接收邮件的过程中,到底这些邮件存储在本机的什么位置,如何才能修改这个存储路径,本文将结合个人经验和大家分享,请看以下详细步骤. 1.打开Windows Li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1D1Pb.html" rel="bookmark" class="title">利用手机管家加速游戏的操作方法</a>
					<div>
						  手机管家是腾讯针纺专门针对安卓手机用户制作的手机清理软件,不过该软件的功能不仅仅是为您的手机清理垃圾文件释放内存,而且它还支持游戏加速的功能,对于该功能很多用户不知道如何操作,故此小编为大家提供了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk6mOb.html" rel="bookmark" class="title">每秒复制15张银行卡的&OpenCurlyDoubleQuote;黑科技&rdquo;，已加入暗网&OpenCurlyDoubleQuote;黑产旗舰店&rdquo;</a>
					<div>
						目前,代号为&quot;CC Buddies&quot;的犯罪组织正在暗网出售一种高科技设备,该设备可以复制非接触式借记卡的数据.&quot;CC Buddies&quot;称他们的设备名为&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxWKnb.html" rel="bookmark" class="title">WKWebView新特性及JS交互</a>
					<div>
						声明 本博文原始地址在: http://mp.weixin.qq.com/s?__biz=MzIzMzA4NjA5Mw==&amp;mid=400327803&amp;idx=1&amp;sn=2a0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQjVYp.html" rel="bookmark" class="title">使用VirtualView渲染的前端UI组件开发模式</a>
					<div>
						在上篇文章中,我讲到我们的组件开发模式解决了以下几个问题 渲染逻辑,业务逻辑,事件分发,控制器彻底分离 组件内部只有一个状态 渲染逻辑只有一处 只绑定一次事件 没有任何学习成本 下面来看我们具体我们是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE8Lmz.html" rel="bookmark" class="title">ios-iOS开发 项目提交苹果审核被拒绝的原因 说名字不对</a>
					<div>
						问题描述 iOS开发 项目提交苹果审核被拒绝的原因 说名字不对 iDPLA 1.2 We continue to find that the Seller and/or Artist names as ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwl5WM.html" rel="bookmark" class="title">一小时玩转云计算 阿里云正式推出培训与认证服务</a>
					<div>
						3月3日,阿里云正式上线培训与认证服务,打造中国知名的云计算和大数据培训与认证平台.该平台通过线上视频.自助实验课以及线下讲师授课等多维度的培训方式,联合众多教育机构与合作伙伴,来帮助学员快速掌握云计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYRYZp.html" rel="bookmark" class="title">Objective-C与JavaScript的交互</a>
					<div>
						     UIWebView是iOS最常用的SDK之一,它有一个stringByEvaluatingJavaScriptFromString方法可以将 javascript嵌入页面中,通过这个方法我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKlEVb.html" rel="bookmark" class="title">《精通Wireshark》&mdash;第2章2&period;2节抓包过滤器</a>
					<div>
						2.2 抓包过滤器 抓包过滤器可以让管理员只抓取自己想要抓取的信息,同时丢弃其他的信息.抓包这个进程是一个处理器密集型任务,同时Wireshark也会占用大量的内存空间.所以,我们有时候需要保留一些资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1r50jp.html" rel="bookmark" class="title">c&num; winform-C&num;窗体应用程序框选怎么实现？</a>
					<div>
						问题描述 C#窗体应用程序框选怎么实现? 在学校里做了一个小实习,用C#在windows窗体上用graphics画了一些点,现在要实现怎么用鼠标拉框选中这些点.我在网上找到一些代码,可以用鼠标拉出虚线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBmvwz.html" rel="bookmark" class="title">《 嵌入式系统设计与实践》一一2&period;4 延伸阅读</a>
					<div>
						2.4 延伸阅读 本章中讨论了众多设计模式中的一些模式.本书其他部分也会讨论一些设计模式,但是本书是关于嵌入式系统的,而不是关于设计模式的.试着从以下这些资源中选择一个进行进一步研究,以便更多地了解标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqoWvb.html" rel="bookmark" class="title">编写高质量代码改善C&num;程序的157个建议&lbrack;用抛异常替代返回错误、不要在不恰当的场合下引发异常、重新引发异常时使用inner Exception&rsqb;</a>
					<div>
						原文:编写高质量代码改善C#程序的157个建议[用抛异常替代返回错误.不要在不恰当的场合下引发异常.重新引发异常时使用inner Exception] 前言 自从.NET出现后,关于CLR异常机制的讨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0ANBM.html" rel="bookmark" class="title">fragment-从Fragment跳转到一个Activity&comma;返回时&comma;怎么回到原来先Fragment</a>
					<div>
						问题描述 从Fragment跳转到一个Activity,返回时,怎么回到原来先Fragment 从Fragment跳转到一个Activity,返回时,怎么回到原来先Fragment并传输数据 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo518M.html" rel="bookmark" class="title">UT斯达康第一季度财报</a>
					<div>
						UT斯达康 (Nasdaq: UTSI )今日宣布,将于美国东部时间2014年5月15日美国股市开盘前(北京时间5月15日晚)发布2014财年第一季度财报. 财报发布后,UT斯达康管理团队将于美国东部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEK0Zop.html" rel="bookmark" class="title">Google构建VR&sol;AR生态系统标准&OpenCurlyDoubleQuote;双平台&rdquo;，高性能传感器同样需验证</a>
					<div>
						集微网消息,近几年以VIVE/Oculus Rift为代表的VR产品的热销,带动了VR市场的兴起,同时随着去年AR游戏的迅速普及和今年春节前支付宝上线了AR实景红包,引爆AR市场,VR/AR已经进入了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Zkggz.html" rel="bookmark" class="title">Android 中ListView setOnItemClickListener点击无效原因分析&lowbar;Android</a>
					<div>
						前言 最近在做项目的过程中,在使用listview的时候遇到了设置item监听事件的时候在没有回调onItemClick 方法的问题.我的情况是在item中有一个Button按钮.所以不会回调.上百度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G66Xp.html" rel="bookmark" class="title">seo优化-百度K站和降权原因大收集</a>
					<div>
						很多站长没有不知不觉的网站就被K了,那么到底是什么原因来,下面我们就来讲讲网站被K或者降权的原因,希望大家引以为戒!一下为总结的几条,如有错误,还请指正: 1:网站服务器不稳定,导致网站经常打不开!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2dKyz.html" rel="bookmark" class="title">linux文件系统（一）&mdash;&mdash;VFS的概念</a>
					<div>
						声明:本Linux文件系统博客,共分四节,是根据网上多个相关博客,以及自己的理解加上相关资料总结而成.(作者:lvyilong316) Linux 之所以能支持除了Ext2文件系统之外的各种文件系统, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWWJWp.html" rel="bookmark" class="title">求一段qt代码，用qcustomPlot读txt文件描点绘数据，求各位大神！</a>
					<div>
						问题描述 求一段qt代码,用qcustomPlot读txt文件描点绘数据,求各位大神! 就下面的一段.txt的数据,第一列是时间做横坐标,分别用第二列第三列的数据画曲线,求各位大神施舍代码呀! m:s ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
